## CongEditorWidget3

CongEditorWidget3 —

## Synopsis

    struct      CongEditorWidget3;
    #define     CONG_EDITOR_WIDGET3             (obj)
    #define     CONG_EDITOR_WIDGET3_CLASS       (klass)
    #define     IS_CONG_EDITOR_WIDGET3          (obj)
    GType       cong_editor_widget3_get_type    (void);
    CongEditorWidget3* cong_editor_widget3_construct
                                                (CongEditorWidget3 *editor_widget,
                                                 CongDocument *doc,
                                                 CongPrimaryWindow *primary_window);
    GtkWidget*  cong_editor_widget3_new         (CongDocument *doc,
                                                 CongPrimaryWindow *primary_window);
    CongDocument* cong_editor_widget3_get_document
                                                (CongEditorWidget3 *editor_widget);
    void        cong_editor_widget3_force_layout_update
                                                (CongEditorWidget3 *editor_widget);
    void        (*CongEditorNodeCallback)       (CongEditorWidget3 *widget,
                                                 CongEditorNode *editor_node,
                                                 gpointer user_data);
    void        cong_editor_widget3_for_each_editor_node
                                                (CongEditorWidget3 *widget,
                                                 CongNodePtr xml_node,
                                                 CongEditorNodeCallback editor_node_callback,
                                                 gpointer user_data);
    CongEditorNode* cong_editor_widget3_get_editor_node_for_traversal_node
                                                (CongEditorWidget3 *editor_widget,
                                                 CongTraversalNode *traversal_node);
    CongEditorNode* cong_editor_widget3_get_editor_node
                                                (CongEditorWidget3 *editor_widget,
                                                 CongNodePtr node,
                                                 CongEditorNode *traversal_parent);
    CongEditorNode* cong_editor_widget3_get_an_editor_node
                                                (CongEditorWidget3 *editor_widget,
                                                 CongNodePtr node);
    CongEditorArea* cong_editor_widget3_get_prehighlight_editor_area
                                                (CongEditorWidget3 *editor_widget);
    void        cong_editor_widget3_set_prehighlight_editor_area
                                                (CongEditorWidget3 *editor_widget,
                                                 CongEditorArea *editor_area);
    GdkGC*      cong_editor_widget3_get_test_gc (CongEditorWidget3 *editor_widget);
    CongEditorArea* cong_editor_widget3_get_area_at
                                                (CongEditorWidget3 *editor_widget,
                                                 gint x,
                                                 gint y);
    const gchar* cong_flow_type_get_debug_string
                                                (CongFlowType flow_type);
    void        editor_popup_build              (CongEditorWidget3 *editor_widget,
                                                 GtkWindow *parent_window);
    void        cong_editor_widget3_add_popup_items
                                                (CongEditorWidget3 *editor_widget,
                                                 GtkMenu *menu);
    void        cong_editor_widget3_get_preedit_data
                                                (CongEditorWidget3 *editor_widget,
                                                 gchar **output_string,
                                                 PangoAttrList **output_pango_attr_list,
                                                 gint *output_cursor_pos);

## Object Hierarchy

      GObject
       +----GtkObject
             +----GtkWidget
                   +----GtkDrawingArea
                         +----CongEditorWidget3

## Implemented Interfaces

CongEditorWidget3 implements AtkImplementorIface.

## Style Properties

      "expander-size"        gint                 : Read

## Description

## Details

### struct CongEditorWidget3

    struct CongEditorWidget3;

### CONG_EDITOR_WIDGET3()

    #define CONG_EDITOR_WIDGET3(obj)         G_TYPE_CHECK_INSTANCE_CAST (obj, CONG_EDITOR_WIDGET3_TYPE, CongEditorWidget3)

`obj` : |

### CONG_EDITOR_WIDGET3_CLASS()

    #define CONG_EDITOR_WIDGET3_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, CONG_EDITOR_WIDGET3_TYPE, CongEditorWidget3Class)

`klass` : |

### IS_CONG_EDITOR_WIDGET3()

    #define IS_CONG_EDITOR_WIDGET3(obj)      G_TYPE_CHECK_INSTANCE_TYPE (obj, CONG_EDITOR_WIDGET3_TYPE)

`obj` : |

### cong_editor_widget3_get_type ()

    GType       cong_editor_widget3_get_type    (void);

Returns : |

### cong_editor_widget3_construct ()

    CongEditorWidget3* cong_editor_widget3_construct
                                                (CongEditorWidget3 *editor_widget,
                                                 CongDocument *doc,
                                                 CongPrimaryWindow *primary_window);

TODO: Write me

`editor_widget` : |
`doc` : |
`primary_window` : |
Returns : |

### cong_editor_widget3_new ()

    GtkWidget*  cong_editor_widget3_new         (CongDocument *doc,
                                                 CongPrimaryWindow *primary_window);

TODO: Write me

`doc` : |
`primary_window` : |
Returns : |

### cong_editor_widget3_get_document ()

    CongDocument* cong_editor_widget3_get_document
                                                (CongEditorWidget3 *editor_widget);

TODO: Write me

`editor_widget` : |
Returns : |

### cong_editor_widget3_force_layout_update ()

    void        cong_editor_widget3_force_layout_update
                                                (CongEditorWidget3 *editor_widget);

`editor_widget` : |

### CongEditorNodeCallback ()

    void        (*CongEditorNodeCallback)       (CongEditorWidget3 *widget,
                                                 CongEditorNode *editor_node,
                                                 gpointer user_data);

`widget` : |
`editor_node` : |
`user_data` : |

### cong_editor_widget3_for_each_editor_node ()

    void        cong_editor_widget3_for_each_editor_node
                                                (CongEditorWidget3 *widget,
                                                 CongNodePtr xml_node,
                                                 CongEditorNodeCallback editor_node_callback,
                                                 gpointer user_data);

TODO: Write me

`widget` : |
`xml_node` : |
`editor_node_callback` : |
`user_data` : |

### cong_editor_widget3_get_editor_node_for_traversal_node ()

    CongEditorNode* cong_editor_widget3_get_editor_node_for_traversal_node
                                                (CongEditorWidget3 *editor_widget,
                                                 CongTraversalNode *traversal_node);

TODO: Write me

`editor_widget` : |
`traversal_node` : |
Returns : |

### cong_editor_widget3_get_editor_node ()

    CongEditorNode* cong_editor_widget3_get_editor_node
                                                (CongEditorWidget3 *editor_widget,
                                                 CongNodePtr node,
                                                 CongEditorNode *traversal_parent);

`editor_widget` : |
`node` : |
`traversal_parent` : |
Returns : |

### cong_editor_widget3_get_an_editor_node ()

    CongEditorNode* cong_editor_widget3_get_an_editor_node
                                                (CongEditorWidget3 *editor_widget,
                                                 CongNodePtr node);

TODO: Write me

`editor_widget` : |
`node` : |
Returns : |

### cong_editor_widget3_get_prehighlight_editor_area ()

    CongEditorArea* cong_editor_widget3_get_prehighlight_editor_area
                                                (CongEditorWidget3 *editor_widget);

TODO: Write me

`editor_widget` : |
Returns : |

### cong_editor_widget3_set_prehighlight_editor_area ()

    void        cong_editor_widget3_set_prehighlight_editor_area
                                                (CongEditorWidget3 *editor_widget,
                                                 CongEditorArea *editor_area);

TODO: Write me

`editor_widget` : |
`editor_area` : |

### cong_editor_widget3_get_test_gc ()

    GdkGC*      cong_editor_widget3_get_test_gc (CongEditorWidget3 *editor_widget);

TODO: Write me

`editor_widget` : |
Returns : |

### cong_editor_widget3_get_area_at ()

    CongEditorArea* cong_editor_widget3_get_area_at
                                                (CongEditorWidget3 *editor_widget,
                                                 gint x,
                                                 gint y);

TODO: Write me

`editor_widget` : |
`x` : |
`y` : |
Returns : |

### cong_flow_type_get_debug_string ()

    const gchar* cong_flow_type_get_debug_string
                                                (CongFlowType flow_type);

TODO: Write me

`flow_type` : |
Returns : |

### editor_popup_build ()

    void        editor_popup_build              (CongEditorWidget3 *editor_widget,
                                                 GtkWindow *parent_window);

TODO: Write me

`editor_widget` : |
`parent_window` : |

### cong_editor_widget3_add_popup_items ()

    void        cong_editor_widget3_add_popup_items
                                                (CongEditorWidget3 *editor_widget,
                                                 GtkMenu *menu);

TODO: Write me

`editor_widget` : |
`menu` : |

### cong_editor_widget3_get_preedit_data ()

    void        cong_editor_widget3_get_preedit_data
                                                (CongEditorWidget3 *editor_widget,
                                                 gchar **output_string,
                                                 PangoAttrList **output_pango_attr_list,
                                                 gint *output_cursor_pos);

TODO: Write me

`editor_widget` : |
`output_string` : |
`output_pango_attr_list` : |
`output_cursor_pos` : |

## Style Properties

"`expander-size`" (gint : Read) | Size of the expander arrow.